/* jcard by dSoft  Version 1.1  */
/* input.c */

#include "jcard.h"

int fgetline (FILE *fp, char *line, int max)
{
  int c;
  int i = 0;

  while ((c = getc(fp)) != '\n' && c != EOF)
    if (i < max)
      line[i++] = c;
  line[i] = '\0';
  return (c == EOF) ? -1 : i;
} /* fgetline */

/* title() - Read in the title of the tape                                  */
/****************************************************************************/
int title (char title_text[][MAX_TITLE])
{
  char title_in[2];
  int title_lines = 0;
  int line_number = 0;

  /* Get how many lines in the title */
  printf ("Title\n=====\n");
  while (title_lines < 1 || title_lines > 2)
    {
      printf ("Enter 1 for a 1-line title, or 2 for a 2-line title: ");
      fgetline (stdin, title_in, 2);
      title_lines = atoi(title_in);
    } /* while */

  /* Get the title */
  while (line_number < title_lines)
    {
      printf ("Enter text for line %i of the title: ", line_number + 1);
      fgetline (stdin, title_text[line_number], MAX_TITLE);
      line_number++;
    } /* while */

  return (title_lines);
} /* title */

/* back() - Read in info for back of jcard: source, generation, nr */
/****************************************************************************/
void back (char source[][MAX_BACK], char gen[][MAX_BACK], char nr[][MAX_BACK])
{
  printf ("\nInfo\n====\n");
  printf ("Source, Side A: ");
  fgetline (stdin, source[0], MAX_BACK);

  printf ("Generation, Side A: ");
  fgetline (stdin, gen[0], MAX_BACK);

  printf ("Noise Reduction, Side A: ");
  fgetline (stdin, nr[0], MAX_BACK);

  printf ("Source, Side B <Default: %s>: ", source[0]);
  fgetline (stdin, source[1], MAX_BACK);
  if (source[1][0] == '\0') strcpy (source[1], source[0]);

  printf ("Generation, Side B <Default: %s>: ", gen[0]);
  fgetline (stdin, gen[1], MAX_BACK);
  if (gen[1][0] == '\0') strcpy (gen[1], gen[0]);

  printf ("Noise Reduction, Side B <Default: %s>: ", nr[0]);
  fgetline (stdin, nr[1], MAX_BACK);
  if (nr[1][0] == '\0') strcpy (nr[1], nr[0]);
  printf ("\n");
} /* back */

Song *songs (FILE *fp, char side)
{
  Song *curr = (Song *)malloc(sizeof(Song));
  Song *list;

  if (!curr) die ("Couldn't allocate memory for song list.");

  if (fp == stdin)
    {
      printf ("Enter song titles for side %c.  ", side);
      printf ("When done, enter a blank line.\n");
    } /* if */

  curr->title = (char *)malloc(MAX_SONG * sizeof(char));
  if (!curr->title) die ("Couldn't allocate memory for next song.");
  curr->next = 0;

  fgetline (fp, curr->title, MAX_SONG);
  list = curr;
  while (curr->title[0] != '\0')
    {
      Song *next = (Song *)malloc(sizeof(Song));
      if (!next) die ("Couldn't allocate memory for next song.");

      next->title = (char *)malloc(MAX_SONG * sizeof(char));
      if (!next->title) die ("Couldn't allocate memory for next song.");

      fgetline (fp, next->title, MAX_SONG);
      next->next = (Song *)0;
      curr->next = next;
      curr = next;
    } /* while */
  curr = 0;
  /* NOTE:  The last node of this list with actual data points to a node  */
  /* with title == "" and next = 0.  You can't check for end of list by   */
  /* checking for null pointer.  You have to check for empty title.  I'll */
  /* fix this someday, but it will require extra pointers n such. */
  return (list);
} /* songs */
