/* jcard.h  Version 1.1 */

#ifndef HEADERS
#define HEADERS
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#endif HEADERS

/* Max length for one line of the title */
#define MAX_TITLE 40
/* Max length for any piece of back info */
#define MAX_BACK 10
/* Max length for a song title */
#define MAX_SONG 40
/* Max length for a file name */
#define MAX_FILENAME 40

/* Data structure to hold lists of song titles */
typedef struct song {
  char *title;
  struct song *next;
} Song;

/* Function prototypes - main.c */
void info (void);
void die (char *message);

/* Function prototypes - input.c */
int fgetline (FILE *fp, char *line, int max);
int title (char title_lines[][MAX_TITLE]);
void back (char source[][MAX_BACK], char gen[][MAX_BACK], char nr[][MAX_BACK]);
Song *songs(FILE *fp, char side);

/* Function prototypes - files.c */
void latex (int, char [][MAX_TITLE], char [][MAX_BACK], char [][MAX_BACK],
	    char [][MAX_BACK]);
void dvi (void);
void ps (void);
void openfile (char *filename, int *title_lines, char title[][MAX_TITLE],
	       char source[][MAX_BACK], char gen[][MAX_BACK],
	       char nr[][MAX_BACK]);
void savefile (int lines, char title[][MAX_TITLE], char source[][MAX_BACK],
	       char gen[][MAX_BACK], char nr[][MAX_BACK]);
