/* jcard by dSoft   Version 1.1  */
/* main.c */

#include "jcard.h"

/* info() - Print weclome message and copyright information                 */
/****************************************************************************/
void info (void)
{
  printf ("jcard by dSoft\nversion 1.1\nJuly 1998\n");
  printf ("(c) 1998 Christopher R. Merlo\n");
  printf ("jcard comes with ABSOLUTELY NO WARRANTY.\n");
  printf ("This is free software, and you are welcome to redistribute it\n");
  printf ("under certain conditions; see readme.txt for details.\n\n");
} /* info */

/* die() - Exit the program gracefully when an error occurs                 */
/****************************************************************************/
void die (char *message)
{
  fprintf (stderr, "Error: %s\n\n", message);
  exit(1);
} /* die */

/* Global variables */
Song *side_a;                  /* List of song titles on side A */
Song *side_b;                  /* List of song titles on side B */

/* main() - Drives everything else.  Duh.                                  */
/****************************************************************************/
int main (int argc, char *argv[])
{
  int title_lines;               /* Number of lines in the title. */
  char title_text[2][MAX_TITLE]; /*title of the tape */
  char source[2][MAX_BACK];      /* Source information on back panel */
  char gen[2][MAX_BACK];         /* Generation information on back panel */
  char nr[2][MAX_BACK];          /* Noise reduction on/off on back panel */
  char save[2];                  /* Do you want to save? */

  info();
  if (argc == 2) /* Filename specified on command line */
    {
      openfile (argv[1], &title_lines, title_text, source, gen, nr);
      latex (title_lines, title_text, source, gen, nr);
      dvi();
      ps();
    } /* command-line filename */
  else if (argc > 2)
    die ("Too many arguments.");
  else /* Read data from stdin */
    {
      title_lines = title(title_text);
      back (source, gen, nr);
      side_a = songs(stdin, 'A');
      side_b = songs(stdin, 'B');
      latex (title_lines, title_text, source, gen, nr);
      dvi();
      ps();
      printf ("Would you like to save this file (y/n)? ");
      fgetline (stdin, save, 2);
      if (save[0] == 'Y' || save[0] == 'y')
	savefile (title_lines, title_text, source, gen, nr);
    } /* read from stdin */
  system ("rm jcard.tex jcard.dvi jcard.aux jcard.log >& /dev/null");
  return(0);
}
